; 4 MHz

.include "tn2313def.inc"

;  
.def temp = r16;
.def temp1= r17;
.def indicator = r18; -    
					; 1 2 3 4  
.def count = r19;

.def flags = r20;
.equ T_Running = 0;	-  0,  / (0/1)
.equ f_load = 1; - 1,  / (0/1)

;  
.equ LED_port = PORTB

.equ LED_CA1 = PD0	;    
.equ LED_CA2 = PD1	;
.equ LED_CA3 = PD5	;
.equ LED_CA4 = PD6	;    

.equ Key_Run = PD2	;  /
.equ Key_min = PD3	;    
.equ Key_sec = PD4	;    

.equ Load = PB7	; 

;    1   4 
.equ T1_coef = 0xCAF6


.cseg
.ORG 0x0000
	rjmp RESET
.ORG 0x0001
	rjmp _INT0; External Interrupt0 Handler
.ORG 0x0002
;	rjmp INT1; External Interrupt1 Handler
.ORG 0x0003
;	rjmp TIM1_CAPT; Timer1 Capture Handler
.ORG 0x0004
;	rjmp TIM1_COMPA; Timer1 CompareA Handler
.ORG 0x0005
	rjmp Time_count; Timer1 Overflow Handler
.ORG 0x0006
	rjmp Dynamic_indication; Timer0 Overflow Handler
.ORG 0x0007
;	rjmp USART0_RXC; USART0 RX Complete Handler
.ORG 0x0008
;	rjmp USART0_DRE; USART0,UDR Empty Handler
.ORG 0x0009
;	rjmp USART0_TXC; USART0 TX Complete Handler
.ORG 0x000A
;	rjmp ANA_COMP; Analog Comparator Handler
.ORG 0x000B
;	rjmp PCINT; Pin Change Interrupt
.ORG 0x000C
;	rjmp TIMER1_COMPB; Timer1 Compare B Handler
.ORG 0x000D
;	rjmp TIMER0_COMPA; Timer0 Compare A Handler
.ORG 0x000E
;	rjmp TIMER0_COMPB; Timer0 Compare B Handler
.ORG 0x000F
;	rjmp USI_START; USI Start Handler
.ORG 0x0010
;	rjmp USI_OVERFLOW; USI Overflow Handler
.ORG 0x0011
;	rjmp EE_READY; EEPROM Ready Handler
.ORG 0x0012
;	rjmp WDT_OVERFLOW; Watchdog Overflow Handler

;
;************************************************************************
;  
.ORG 0x0013
RESET:
ldi temp, low(RAMEND)	;  
out SPL, temp;

;  
ldi temp, 0x7F
out LED_port, temp	;  

ldi temp, 0xFF
out DDRB, temp		;   

ldi temp, (1<<Key_Run)|(1<<Key_min)|(1<<Key_sec)
out PORTD, temp

ldi temp, (1<<LED_CA1)|(1<<LED_CA2)|(1<<LED_CA3)|(1<<LED_CA4)
out DDRD, temp


;      
;   -  EEPROM
ldi temp, 0x00
sts min_tens, temp
sts min_unit, temp
sts sec_tens, temp
sts sec_unit, temp

ldi indicator, 0x00
ldi count, 0x00
ldi flags, 0x00


;   
;      T0
;   ~100 Hz
ldi temp, 0xD8
out TCNT0, temp

in temp, TIMSK			;    
ori temp, (1<<TOIE0)	;  0
out TIMSK, temp

ldi temp, (1<<TOV0)		;   ( )
out TIFR, temp

ldi temp, (1<<CS02)|(1<<CS00)
out TCCR0B, temp

sei


;   1   
ldi temp, HIGH(T1_coef)
out TCNT1H, temp

ldi temp, LOW(T1_coef)
out TCNT1L, temp

in temp, TIMSK			;    
ori temp, (1<<TOIE1)	;  0
out TIMSK, temp


;     1
ldi temp, (1<<ISC01)
out MCUCR, temp		;    

in temp, GIMSK
ori temp, (1<<INT0)
out GIMSK, temp


;************************************************************************
main_cycle:




rjmp main_cycle
;************************************************************************

Dynamic_indication:
push temp
push temp1
in temp, SREG
push temp

	ldi temp, 0xD8
	out TCNT0, temp
	
	;  
	ldi temp, 0x7F
	out LED_port, temp
	;   
	cbi PORTD, LED_CA1
	cbi PORTD, LED_CA2
	cbi PORTD, LED_CA3
	cbi PORTD, LED_CA4
ind1:	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	cpi indicator, 0x00
	brne ind2
	lds temp, min_tens	;   
	ldi temp1, 0x00
	ldi ZH, HIGH(2*Digits)
    ldi ZL, LOW(2*Digits)
	add ZL, temp
	adc ZH, temp1
	lpm temp, Z
	; ,    
	;  ,   
	sbrs flags, f_load
	cbr temp, (1<<Load)

	out LED_port, temp
	sbi PORTD, LED_CA1
	inc indicator
	rjmp ind_
ind2:	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	cpi indicator, 0x01
	brne ind3
	lds temp, min_unit	;   
	ldi temp1, 0x00
	ldi ZH, HIGH(2*Digits)
    ldi ZL, LOW(2*Digits)
	add ZL, temp
	adc ZH, temp1
	lpm temp, Z

	sbrs flags, f_load
	cbr temp, (1<<Load)

	out LED_port, temp
	sbi PORTD, LED_CA2
	inc indicator
	rjmp ind_
ind3:	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	cpi indicator, 0x02
	brne ind4
	lds temp, sec_tens	;   
	ldi temp1, 0x00
	ldi ZH, HIGH(2*Digits)
    ldi ZL, LOW(2*Digits)
	add ZL, temp
	adc ZH, temp1
	lpm temp, Z

	sbrs flags, f_load
	cbr temp, (1<<Load)

	out LED_port, temp
	sbi PORTD, LED_CA3
	inc indicator
	rjmp ind_
ind4:	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	cpi indicator, 0x03
	brne ind_
	lds temp, sec_unit	;   
	ldi temp1, 0x00
	ldi ZH, HIGH(2*Digits)
    ldi ZL, LOW(2*Digits)
	add ZL, temp
	adc ZH, temp1
	lpm temp, Z

	sbrs flags, f_load
	cbr temp, (1<<Load)

	out LED_port, temp
	sbi PORTD, LED_CA4
	inc indicator
	rjmp ind_
ind_:	;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	cpi indicator, 0x04
	brlo ind_good
	ldi indicator, 0x00

ind_good:;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;    /
;        
inc count
cpi count, 40
brlo _no_ready
ldi count, 0x00
;  
sbrc flags, T_Running
rjmp _no_ready

;    2 -  
sbic PIND, Key_min
rjmp _L1
	lds temp1, min_tens
	lds temp, min_unit
	inc temp
	cpi temp, 10
	brlo _L11
		ldi temp, 0x00
		inc temp1
		cpi temp1, 10
		brlo _L11
		ldi temp1, 0x00

	_L11:
	;   
	sts min_tens, temp1
	sts back_mt, temp1
	sts min_unit, temp
	sts back_mu, temp

_L1:
;    3 -  
sbic PIND, Key_sec
rjmp _L2
	lds temp1, sec_tens
	lds temp, sec_unit
	inc temp
	cpi temp, 10
	brlo _L12
		ldi temp, 0x00
		inc temp1
		cpi temp1, 6
		brlo _L11
		ldi temp1, 0x00

	_L12:
	sts sec_tens, temp1
	sts back_st, temp1
	sts sec_unit, temp
	sts back_su, temp


_L2:
_no_ready:

pop temp
out SREG, temp
pop temp1
pop temp
reti
;************************************************************************



Time_count:
push temp
push temp1
in temp, SREG
push temp

	ldi temp, HIGH(T1_coef)
	out TCNT1H, temp

	ldi temp, LOW(T1_coef)
	out TCNT1L, temp

	lds temp, sec_unit
	lds temp1, sec_tens

	subi temp, 1
	brge sec_unit_dec_ok
	ldi temp, 0x09
	sts sec_unit, temp
	
		subi temp1, 1
		brge sec_tens_dec_ok
		ldi temp1, 0x05
		sts sec_tens, temp1

		lds temp, min_unit
		lds temp1, min_tens

			subi temp, 1
			brge min_unit_dec_ok
			ldi temp, 0x09
			sts min_unit, temp

			subi temp1, 1
			brge min_tens_dec_ok
			ldi temp1, 0x00
			sts min_tens, temp1
			;   ,     
			sts min_unit, temp1
			sts sec_tens, temp1
			sts sec_unit, temp1

			;   
			;  
			cbr flags, (1<<T_Running)
			ldi temp, 0x00
			out TCCR1B, temp
			;    
			sbr flags, (1<<f_load)
			;  
			sbi LED_port, Load 

			rjmp _L41


	sec_unit_dec_ok:
	sts sec_unit, temp
	rjmp _L41

	sec_tens_dec_ok:
	sts sec_tens, temp1
	rjmp _L41
	
	min_unit_dec_ok:
	sts min_unit, temp
	rjmp _L41

	min_tens_dec_ok:
	sts min_tens, temp1


_L41:

; ,     


pop temp
out SREG, temp
pop temp1
pop temp
reti
;************************************************************************


_INT0:
push temp
push temp1
in temp, SREG
push temp

; ,   .  ,  ,  
;      .

sbrs flags, f_Load
rjmp _L32

cbr flags, (1<<f_Load)
cbi LED_port, Load
; 
lds temp, back_mt
sts min_tens, temp

lds temp, back_mu
sts min_unit, temp

lds temp, back_st
sts sec_tens, temp

lds temp, back_su
sts sec_unit, temp
;
rjmp _L31


;  ,   
_L32:
;   T_Running
	ldi temp, (1<<T_Running)
	eor flags, temp

;   == 1,  
; ,  
	sbrc flags, T_Running	; ,  
	rjmp T1_Run				; 

	sbrs flags, T_Running
	rjmp T1_Pause
	

T1_Run:	;   1 PRESCALER /256
	ldi temp, (1<<CS12);
	out TCCR1B, temp;
	rjmp _L31
	

T1_Pause: ;   1
	ldi temp, 0x00
	out TCCR1B, temp
	rjmp _L31


_L31:

pop temp
out SREG, temp
pop temp1
pop temp
reti
;************************************************************************



;  
;      
Digits: .DB 0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90
;            0     1     2     3     4     5     6     7     8     9



;************************************************************************
.DSEG
min_tens: .BYTE 1
min_unit: .BYTE 1

sec_tens: .BYTE 1
sec_unit: .BYTE 1

back_mt: .BYTE 1
back_mu: .BYTE 1

back_st: .BYTE 1
back_su: .BYTE 1

;indicator: .BYTE 1
